Subject: bug#5108: closed (Re: bug#5108: 23.1; ps-print-buffer infinite loop on image-mode)

From: [email-masked] (GNU bug Tracking System)
Date: Mon, 19 Sep 2011 19:33:02 +0000

Your bug report

#5108: 23.1; ps-print-buffer infinite loop on image-mode

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
5108: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=5108
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#5108: 23.1; ps-print-buffer infinite loop on image-mode
From: Stefan Monnier <[email-masked]>
To: Lars Magne Ingebrigtsen <[email-masked]>
Cc: [email-masked], Kevin Ryde <[email-masked]>
Date: Mon, 19 Sep 2011 15:27:36 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

>> (with-temp-buffer
>>   (insert-file-contents (concat data-directory "images/cut.xpm"))
>>   (image-mode)
>>   (ps-print-buffer "/tmp/foo.ps"))
>> shows message
>> Formatting...  0%
>> and then goes away apparently forever.
> I can confirm that this bug is still present in Emacs 24.

Yes, it's the evil `intangible' property at work.
I've installed the patch below which should fix the immediate
inf-loop problem.  I also removed the intangible property from
image-mode to avoid similar problems in other codes.

        Stefan

--- lisp/ps-mule.el	2011-04-19 13:44:55 +0000
+++ lisp/ps-mule.el	2011-09-19 18:57:29 +0000
@@ -659,7 +659,7 @@
 	 width)
     (goto-char from)
     (while (not endpos)
-      (cond ((= (point) stop)
+      (cond ((>= (point) stop)
 	     (if (= stop to)
 		 (setq endpos stop)
 	       (when (< from stop)

Subject: 23.1; ps-print-buffer infinite loop on image-mode
From: Kevin Ryde <[email-masked]>
To: [email-masked]
Date: Thu, 03 Dec 2009 09:26:27 +1100

A ps-print-buffer on some image files in image-mode goes into an
infinite loop.  For example "cut.xpm" in the current emacs cvs,

    (progn
      (switch-to-buffer "x")
      (erase-buffer)
      (insert-file-contents (concat data-directory "images/cut.xpm"))
      (image-mode)
      (ps-print-buffer "/tmp/foo.ps"))

shows message

    Formatting...  0%

and then goes away apparently forever.

debug-on-quit says the loop is ps-mule-plot-string.  It seems (point)
has gone past the intended `stop' position, so "(= (point) stop)" is not
satisfied, or something like that.  Might be the forward-char under
"(looking-at ascii-or-latin-1)" going too far, maybe something to do
with the image overlay, or point movement within image mode ...

(What I actually hoped for was that it might print the image, but
perhaps it doesn't print images at all ...)

In GNU Emacs 23.1.1 (i486-pc-linux-gnu, GTK+ Version 2.16.5)
 of 2009-09-14 on raven, modified by Debian
configured using `configure  '--build=i486-linux-gnu' '--host=i486-linux-gnu' '--prefix=/usr' '--sharedstatedir=/var/lib' '--libexecdir=/usr/lib' '--localstatedir=/var/lib' '--infodir=/usr/share/info' '--mandir=/usr/share/man' '--with-pop=yes' '--enable-locallisppath=/etc/emacs23:/etc/emacs:/usr/local/share/emacs/23.1/site-lisp:/usr/local/share/emacs/site-lisp:/usr/share/emacs/23.1/site-lisp:/usr/share/emacs/site-lisp:/usr/share/emacs/23.1/leim' '--with-x=yes' '--with-x-toolkit=gtk' '--with-toolkit-scroll-bars' 'build_alias=i486-linux-gnu' 'host_alias=i486-linux-gnu' 'CFLAGS=-DDEBIAN -g -O2' 'LDFLAGS=-g' 'CPPFLAGS=''

Important settings:
  value of $LC_ALL: nil
  value of $LC_COLLATE: nil
  value of $LC_CTYPE: nil
  value of $LC_MESSAGES: nil
  value of $LC_MONETARY: nil
  value of $LC_NUMERIC: nil
  value of $LC_TIME: nil
  value of $LANG: en_AU
  value of $XMODIFIERS: nil
  locale-coding-system: iso-latin-1-unix
  default-enable-multibyte-characters: t